/*----------------------------------------------------------------------------*/
/*
  This file is generated by Code_Saturne, a general-purpose CFD tool.
*/
/*----------------------------------------------------------------------------*/

#include "cs_defs.h"

/*----------------------------------------------------------------------------
 * Standard C library headers
 *----------------------------------------------------------------------------*/

#include <assert.h>
#include <math.h>

#if defined(HAVE_MPI)
#include <mpi.h>
#endif

/*----------------------------------------------------------------------------
 *  Local headers
 *----------------------------------------------------------------------------*/

#include "cs_headers.h"
/*----------------------------------------------------------------------------*/

BEGIN_C_DECLS

/*----------------------------------------------------------------------------*/

cs_real_t *
cs_meg_initialization(const cs_zone_t *zone,
                      const char      *field_name)
{
  cs_real_t *new_vals = NULL;

  /*-----------------------------------------------------------------------*/
  /* User defined initialization for variable velocity over zone all_cells */
  if (strcmp(zone->name, "all_cells") == 0 &&
      strcmp(field_name, "velocity") == 0 ) {

    const int vals_size = zone->n_elts * 3;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);

    for (cs_lnum_t e_id = 0; e_id < zone->n_elts; e_id++) {
      cs_lnum_t c_id = zone->elt_ids[e_id];
      new_vals[3 * e_id + 0] = 0.;
      new_vals[3 * e_id + 1] = 0.;
      new_vals[3 * e_id + 2] = 0.;
    }
  }
  /*-----------------------------------------------------------------------*/

  /*----------------------------------------------------------------------*/
  /* User defined initialization for variable thermal over zone all_cells */
  if (strcmp(zone->name, "all_cells") == 0 &&
      strcmp(field_name, "thermal") == 0 ) {

    const int vals_size = zone->n_elts * 1;
    BFT_MALLOC(new_vals, vals_size, cs_real_t);

    for (cs_lnum_t e_id = 0; e_id < zone->n_elts; e_id++) {
      cs_lnum_t c_id = zone->elt_ids[e_id];
      new_vals[e_id] = 20.;
    }
  }
  /*----------------------------------------------------------------------*/

  return new_vals;
}

/*----------------------------------------------------------------------------*/

END_C_DECLS

